/*
FIXME
	TEST
	s-t平面
	delaunay
	const定数

	vector<>化
	
	三角形クラスを外に

	幾何計算の関数を別にする
*/

// FIXME データ構造
/*	STL化
	アルゴリズムとの分離
	(x, y)を得る関数を分離する
*/

// trianglesは使用後解放する必要がある
// 毎回trianglesを一から作りなおすことになる

#ifndef _DELAUNEY_H_
#define _DELAUNEY_H_

#include <vector>
#include "triangle.h"
#include "vector3.h" // FIXME vector3f

const int DELAUNEY_INIT_PTSIZE = 5;
const int DELAUNEY_INIT_TRISIZE = 5;
const int DELAUNEY_INIT_STACKSIZE = 5;

class adjacent{
public:
	adjacent(void){
		for(int i = 0; i < 3; i++) adj[i] = -1;
	}

	adjacent(int ip0, int ip1, int ip2){
		set(ip0, ip1, ip2);
	}

	void set(int ip0, int ip1, int ip2){
		adj[0] = ip0;
		adj[1] = ip1;
		adj[2] = ip2;
	}

	bool SetAdjacent(int edge, int triangle){
		if(edge < 0 || edge > 2) return false;
		adj[edge] = triangle;
		return true;
	}

	int GetAdjacent(int edge){
		if(edge < 0 || edge > 2) return -1;
		return adj[edge];
	}

private:
	int adj[3];	// adjacent[edge]
};

class delaunay {
public:

// init
	delaunay();
	~delaunay();

// delaunay
	std::vector<triangle>* make_triangle(std::vector<vector3d> *vertics);

	bool AddPtPos(int index);
		// (x, y)を分割に加え、新たな分割を行う．
		// 追加、分割に失敗した場合はFALSEを返す．

// vertics 
	int add_vertex(double x, double y);
		// 返り値は登録した点の番号

	bool GetPtPos(int iPt, double& x, double& y);
		// iPt番目の点の座標を(x, y)に返す．
		// iPtに存在しない点の番号を与えた場合等で失敗した場合はFALSEが返る．

// triangles
	int add_triangle(int a, int b, int c);
		// 返り値は登録した三角形の番号

	bool GetPtOfTri(int iTri, int& ip0, int& ip1, int& ip2);
		// iTri番目の三角形をなす3つの頂点の番号を返す

	int FindTriContains(double x, double y);
		// (x, y)を内部に含む三角形の番号を返す
		// 見つからなければ-1

// triangle
	bool IsInside(int iTri, double x, double y);
		// (x, y)がiTri番目の三角形の中にあればTRUE

	bool SwapDiagonal(int iTri0, int iTri1);
		// 対角線の交換

// adjacent
	int add_adjacent(adjacent pTri);
		// 返り値は登録した三角形の番号

	bool SetAdjacent(int iTri0, int iTri1);
		// iTri0とiTri1が隣接しているとする．
		// ただし本当に隣り合っている場合しか成功しない．
		// iTri0とiTri1に共通辺がない場合は失敗し、FALSEを返す．

	int GetAdjacent(int iTri, int iEdge);
		// iTriの辺iEdgeに対応する辺に隣接する三角形を返す
		// ない場合は-1が返る

	bool IsAdjacent(int iTri0, int iTri1, int& c0, int& c1);
		// iTri0とiTri1が隣接しているか調べる．
		// 隣接しているならTRUE. そうでなければFALSE.
		//
		// c0 = 共通辺の番号（iTri0から見た場合）
		// c1 = 共通辺の番号（iTri1から見た場合）
		// （なお、返り値がFALSEだった場合はc0, c1は意味を持たない）

// 数学
	bool IsInside(double ax, double ay,
					double bx, double by,
					double cx, double cy,
					double x, double y);

	void CalcCircumCircle(
		double x0, double y0, double x1, double y1, double x2, double y2,
		double& cx, double& cy, double& r2);
		// (x0, y0), (x1, y1), (x2, y2)で作られる三角形の外接円を計算し、
		// その中心座標を(cx, cy)に、半径の二乗をr2に返す．

	bool IsPlusRotation(double x0, double y0, double x1, double y1);
		// ベクトル(x0, y0)から正の方向に回転した位置に(x1, y1)があるならTRUE.
		// 3次元ベクトルの外積を使って判定する．

private:
	std::vector<vector3d>* vertics;
	std::vector<triangle> *triangles;
	std::vector<adjacent> m_pTri;	// FIXME:various name
};

#endif
