#ifndef __image_h__
#define __image_h__

struct RGBA_space{
	unsigned long int Rmask;
	unsigned long int Gmask;
	unsigned long int Bmask;
	unsigned long int Amask; //	α値は、0なら透明、255なら不透明

	int num_trans;	// 透過色
	unsigned long int *trns;
};

struct colors{
	unsigned int r;	// red
	unsigned int g;	// green
	unsigned int b; // blue
};

struct plte_space{
	colors* palette;
	int num_palette;

	int num_trans; // 透過色
	colors *trns;
};

union color_space{
	RGBA_space rgba;
	plte_space plte;
};

// FIXME enum
class image {
public:

	image(void);
	virtual ~image(void);

	virtual bool open(char *file_name){return false;};

// 画像データ
	unsigned char *pixels;
	unsigned long int width;	/* [pixel] */
	unsigned long int height;	/* [pixel] */
	int bit_per_pixel;
	unsigned int pitch;	/* [byte] 通常は((width + 7) * (bit_per_pixel / 8)) */

	enum type{ GRAY, GRAY_ALPHA, PALETTE, RGB, RGB_ALPHA, MASK };
	type get_color_type(void);


// 画像タイプ判別
	enum COLOR_SPACE{ PLTE, RGBA };
	enum COLOR_SPACE color;
	color_space space;

private:
};

/* FIXME :
 *	画像タイプについて
 *		PALETTE
 *
 *		マスクを使用
 *		GLAY_SCALE
 *		GLAY_SCALE + Alpha
 *		RGB
 *		RGBA
 *
 *	PNGの場合 image_pngもおかしいかもね
 *	PNG_COLOR_TYPE_GRAY
 *		(ビット深度 1, 2, 4, 8, 16)
 *	PNG_COLOR_TYPE_GRAY_ALPHA
 *		(ビット深度 8, 16)
 *	PNG_COLOR_TYPE_PALETTE
 *		(ビット深度 1, 2, 4, 8)
 *	PNG_COLOR_TYPE_RGB
 *		(ビット深度 8, 16)
 *	PNG_COLOR_TYPE_RGB_ALPHA
 *		(ビット深度 8, 16)
 *	PNG_COLOR_MASK_PALETTE
 *	PNG_COLOR_MASK_COLOR
 *	PNG_COLOR_MASK_ALPHA
 *
 *	pitch
 *		((width + 7) * (bit_per_pixel / 8))ってなんだっけ？
 *		使い道も忘れた
 *
 */

#endif // __ht_image_h


