#ifndef __screen_h
#define __screen_h

#include <set>
#include "rect.h"

struct SDL_Surface;

class image;

class screen{
public:

	screen(void);
	~screen(void);

	enum FLAGS {
		SWSURFACE,
		HWSURFACE,
		ASYNCBLIT,
		ANYFORMAT,
		HWPALETTE,
		DOUBLEBUF,
		FULLSCREEN,
		OPENGL,
		OPENGLBLIT,
		RESIZABLE,
		NOFRAME
	};

	int set_screen(int width, int height, int bpp, int flags);

	int set_surface(SDL_Surface *surface, rect *source, rect *destination);
	int set_surface(image *surface, rect *source, rect *destination);

	void update(void);

	SDL_Surface *surface;
private:

	int set_surface_imp(SDL_Surface *surface, rect *source, rect *destination);

	// 쥳ɤ: nameեɤΤߤӤоݤȤ
	struct less_rect: std::binary_function<rect,rect,bool> {
		bool operator()(const rect& x, const rect& y) const {
			if(x.x != y.x){
				return x.x < y.x;
			}else if(x.y != y.y){
				return x.y < y.y;
			}else if(x.w != y.w){
				return x.w < y.w;
			}else{
				return x.h < y.h;
			}
		}
	};

	std::set<rect, less_rect> rects;

	int width;
	int height;
	int bpp;
	unsigned int flags;
};

#endif
