
/*
最低限の機能だけのTETRIS
map	10 * 18
block 4 * 4
左上を(0, 0)とする

ブロックは(4, 4)から落ちてくる
4 + 横4 + 2
4 + 横3 + 3
5 + 横2 + 3
*/

// 座標なども全て0から数える
// FIXME publicの関数内でデータ構造に触らない

class tetris{
public:
	tetris(void);
	~tetris(void);

// 処理
	// 初期化処理
	void init(void);
	// ブロックを置く
	// return false;ゲームオーバー
	bool decide(void);

	// 可能なら一番下まで移動してから
	// 現在の位置にブロックを置く
	void put_block(void);
	// 一列揃ったラインを消す
	// 返り値 消したライン数
	int delete_line(void);
	// 新しいブロックを得る
	// ブロックの初期位置を決定(全部入ること)
	// ゲームオーバーの判定: return false 
	bool get_new_block(void);
	// マップをクリアする
	void clear_map(void);

// 設定
	// mapの(x, y)をブロックで埋める
	void set_map(int x, int y, bool value);
	// block_type 0から数える
	void set_current_block_type(int type);
	void set_next_block_type(int type);
	void set_block_position(int x, int y);

// 描画用
	// mapの(x, y)がブロックで埋まっているかどうか
	bool get_map(int x, int y);
	// ブロックの現在位置を取得
	inline int get_block_x(void){return block_x;}
	inline int get_block_y(void){return block_y;}
	// blockの(x, y)がブロックで埋まっているかどうか
	bool get_block(int x, int y);
	
// 操作
	// ブロックを移動する
	// 返り値 移動できないときはfalse、それ以外はtrue
	bool move_right(void);
	bool move_left(void);
	bool move_down(void);
	// 一番下まで移動
	void move_buttom(void);

	// ブロックを回転
	bool turn_right(void);
	bool turn_left(void);

// コリジョン
	// blockを(x, y)に置くと衝突する
	// 置けない:return true;
	// 置ける:return false;
	bool check_collision(int x, int y);

private:
	bool get_block(char *src, int x, int y);
	bool check_collision(char *src, int x, int y);
	void set_block(char *dst, int x, int y, bool value);
	void copy_block(char *src, char*dst);

// マップ
	// 10 * 18, 一列を2byteで表す
	// 右上を(0, 0)とする
	char map[36];

// ブロック
	char *blocks;	// ブロックのデータ
	char *current_block; // 現在のブロック
	int current_block_type; // ブロックの種類
	int next_block_type; // ブロックの種類
	int block_x; // ブロックの現在位置
	int block_y;
};

