
#include <GL/gl.h>
#include <iostream>
using namespace std;

double gl_get_pixel_position(int pos, int max){
	return 2.0 * (double)((double)pos / (double)max) - 1.0;
}

void gl_draw_square(int x, int y, int w, int h,
				int max_w, int max_h){
	double x0 = gl_get_pixel_position(x, max_w);
	double y0 = gl_get_pixel_position(y, max_h);
	double x1 = gl_get_pixel_position(x + w, max_w);
	double y1 = gl_get_pixel_position(y + h, max_h);

	glBegin(GL_QUADS);
		glVertex2d(x0, y0);
		glVertex2d(x0, y1);
		glVertex2d(x1, y1);
		glVertex2d(x1, y0);
	glEnd();

}

void gl_axis(double length, int n){
	glBegin(GL_LINES);
		for(double i = 0.0; i < length; i += length / n){
			glVertex3d(-length, 0, (double)i);
			glVertex3d(length, 0, (double)i);
			glVertex3d(-length, 0, -(double)i);
			glVertex3d(length, 0, -(double)i);

			glVertex3d((double)i, 0, length);
			glVertex3d((double)i, 0, -length);
			glVertex3d(-(double)i, 0, length);
			glVertex3d(-(double)i, 0, -length);
		}
	glEnd();
}

void gl_2d_point(int x, int y, int max_w, int max_h){
	gl_draw_square(x, y, 1, 1,
				max_w, max_h);
}

// ľ
void gl_2d_line(int x0, int y0, int x1, int y1, int max_w, int max_h){
	double dx0 = gl_get_pixel_position(x0, max_w);
	double dy0 = gl_get_pixel_position(y0, max_h);
	double dx1 = gl_get_pixel_position(x1, max_w);
	double dy1 = gl_get_pixel_position(y1, max_h);

	glBegin(GL_LINES);
		glVertex2d(dx0, dy0);
		glVertex2d(dx1, dy1);
	glEnd();
}


