#include "gl_projection.h"
#include "vector3.h"
#include <GL/gl.h>
#include <GL/glu.h>
#include <iostream>
using namespace std;

/* Some useful constants.  */
# define M_E		2.7182818284590452354	/* e */
# define M_LOG2E	1.4426950408889634074	/* log_2 e */
# define M_LOG10E	0.43429448190325182765	/* log_10 e */
# define M_LN2		0.69314718055994530942	/* log_e 2 */
# define M_LN10		2.30258509299404568402	/* log_e 10 */
# define M_PI		3.14159265358979323846	/* pi */
# define M_PI_2		1.57079632679489661923	/* pi/2 */
# define M_PI_4		0.78539816339744830962	/* pi/4 */
# define M_1_PI		0.31830988618379067154	/* 1/pi */
# define M_2_PI		0.63661977236758134308	/* 2/pi */
# define M_2_SQRTPI	1.12837916709551257390	/* 2/sqrt(pi) */
# define M_SQRT2	1.41421356237309504880	/* sqrt(2) */
# define M_SQRT1_2	0.70710678118654752440	/* 1/sqrt(2) */


gl_projection::gl_projection(){
// ƩѴ
	fovy = 0.0;
	aspect = 0.0;
	near = 0.0;
	far = 0.0;

// 
	mode = CENTER;
	eye = new vector3d;
	center = new vector3d;
	up = new vector3d;

	load_identity();
}

gl_projection::~gl_projection(){
	delete eye;
	delete center;
	delete up;
}

void gl_projection::set_center(double x, double y, double z){
	if(mode == CENTER){
		*center = vector3d(x, y, z);
	}else if(mode == EYES){
		*center = vector3d(x, y, z);
	}
}

void gl_projection::roll(double angle_x, double angle_y){
	if(mode == CENTER){
		if(angle_x != 0.0){
			// FIXME ,ˤȤ
			*eye -= *center;
			vector3d axi = *up;
			axi = axi.cross_product(*eye);
			*eye += eye->cross_product(axi.normalize() * (angle_x / 360));
			*eye += *center;
		}

		// eyeupμǲž
		if(angle_y != 0.0){
			*eye -= *center;
			*eye += eye->cross_product(up->normalize() * (angle_y / 360));
			*eye += *center;
		}
	}else if(mode == EYES){
		if(angle_x != 0.0){
			vector3d axi = *up;
			axi = axi.cross_product(*eye);
			*center += center->cross_product(axi.normalize() * (angle_x / 360));
		}

		// eyeupμǲž
		if(angle_y != 0.0){
			*center += center->cross_product(up->normalize() * (angle_y / 360));
		}
	}
}

// FIXME glTranslateȤޤ路Τmove()ѹ
void gl_projection::translate(double x, double y, double z){
	*eye += vector3d(x, y, z);

	if(mode == CENTER){
	}else if(mode == EYES){
		*eye += vector3d(x, y, z);
	}
}

void gl_projection::distance(double d){
	if(mode == CENTER){
		*eye -= *center;
		if((eye->get_r() + d) > 0) eye->transform(d, 0.0, 0.0);
		*eye += *center;
	}else if(mode == EYES){
		if((eye->get_r() + d) > 0) eye->transform(d, 0.0, 0.0);
	}
}

void gl_projection::load_identity(void){
	if(mode == CENTER){
		*center = vector3d(0.0, 0.0, 0.0);
		*eye = vector3d(0.0, 0.0, 0.0);
		*up = vector3d(0.0, 1.0, 0.0);
	}else if(mode == EYES){
		*center = vector3d(0.0, 0.0, -1.0);
		*eye = vector3d(0.0, 0.0, 0.0);
		*up = vector3d(0.0, 1.0, 0.0);
	}
}

void gl_projection::set_GL_PROJECTION(void){
	// FIXME glMatrixMode򸵤ˤɤ
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();

	gluPerspective(fovy, aspect, near, far);

	if(mode == CENTER){
		gluLookAt(eye->get_x(), eye->get_y(), eye->get_z(),
			center->get_x(), center->get_y(), center->get_z(),
			up->get_x(), up->get_y(), up->get_z());
	}else if(mode == EYES){
		gluLookAt(eye->get_x(), eye->get_y(), eye->get_z(),
			eye->get_x() + center->get_x(),
			eye->get_y() + center->get_y(),
			eye->get_y() + center->get_z(),
			up->get_x(), up->get_y(), up->get_z());
	}
}


// perspective --------------------------------------------
void gl_projection::set_perspective(double y, double a, double n, double f){
	fovy = y;
	aspect = a;
	near = n;
	far = f;
}

void gl_projection::set_aspect(double a){
	aspect = a;
}

