#include "gl_texture.h"

/*
	FIXME:2のべき乗制限の回避
	0. 画像のサイズを事前に調整
	1. 余白のある画像を使用する
	2. 画像を読み込んで、余白を付ける
	3. リサイズする
		glScaleImage()
	4. 画像を読み込む際に、余白を付ける
		image_pngを改変
*/
/*
	FIXME:ミップマップ
*/
void make_texture(GLuint *texName, image *tex){
	
	//ピクセル格納モードの制御
	// ASLIGNMET : アラインメント : バイトの並び
	// この場合は一列(8n + m)ビットの並びを強制的に一列(n + 1)バイトで表現する
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);

	// テクスチャオブジェクト
	glGenTextures(1, texName); //名前を付ける
	glBindTexture(GL_TEXTURE_2D, *texName); //作成

	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);

	// テクスチャの大きさ、種類、位置などを指定する
	glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, tex->width, tex->height,
				0, GL_RGB, GL_UNSIGNED_BYTE, tex->pixels);

}

