
hight_map::hight_map(void){
	img = new image_png;

}

hight_map::~hight_map(void){
	img->close();
	delete img;
}

void hight_map::open(char *filename){
	if((img->open(filename)) == false){
		cout << "error tex->open" << endl;
		return;	// FIXME エラー処理
	}
	// FIXME imageのカラーモード指定方法
	
//texture
	//ピクセル格納モードの制御
	// ASLIGNMET : アラインメント : バイトの並び
	// この場合は一列(8n + m)ビットの並びを強制的に一列(n + 1)バイトで表現する
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);

	// テクスチャオブジェクト
	glGenTextures(1, &texture); //名前を付ける
	glBindTexture(GL_TEXTURE_2D, texture); //作成

	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);

	// テクスチャの大きさ、種類、位置などを指定する
	glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, img->width, img->height,
				0, GL_RGBA, GL_UNSIGNED_BYTE, img->pixels);

// vertex data
	for(int x = 0; x < img->width; x++){
		for(int z = 0; z < img->height; z++){
			if(img->pixels[(z * img->width + x) * 4]){
				map.push_back(vector3d((double)x / 128.0 - 1.0, 0.5, (double)z / 128.0 - 1.0));
			}else{
				map.push_back(vector3d((double)x / 128.0 - 1.0, 0.0, (double)z / 128.0 - 1.0));
			}
		}
	}
	
}

void hight_map::render(void){
	glEnable(GL_TEXTURE_2D);
	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);
	glBindTexture(GL_TEXTURE_2D, texture);

	glBegin(GL_QUADS);
		glTexCoord2f(0.0, 0.0);	glVertex3f(-1.0, 0.0, -1.0);
		glTexCoord2f(0.0, 1.0);	glVertex3f(-1.0, 0.0, 1.0);
		glTexCoord2f(1.0, 1.0);	glVertex3f(1.0, 0.0, 1.0);
		glTexCoord2f(1.0, 0.0);	glVertex3f(1.0, 0.0, -1.0);
	glEnd();

	glDisable(GL_TEXTURE_2D);

	glBegin(GL_POINTS);
		for(vector<vector3d>::iterator i = map.begin(); i != map.end();i++){
			glVertex3d(i->get_x(), i->get_y(), i->get_z());
		}
	glEnd();
}


