
#include "image.h"
#include <cstdlib>

image::image(void){

	pixels = 0;
	width = 0;
	height = 0;
	bit_per_pixel = 0;
	pitch = 0;

	color = RGBA;
	space.rgba.trns = 0;
}

image::~image(void){
	if(pixels) free(pixels);
	pixels = 0;

	if(color == RGBA){
		if(space.rgba.trns) free(space.rgba.trns);
		space.rgba.trns = 0;
	}else if(color == PLTE){
		if(space.plte.trns) free(space.plte.trns);
		space.plte.trns = 0;
	}
}


image::type image::get_color_type(void){

	if(color == PLTE) return PALETTE;
	unsigned long int Rmask = space.rgba.Rmask;
	unsigned long int Gmask = space.rgba.Gmask;
	unsigned long int Bmask = space.rgba.Bmask;
	unsigned long int Amask = space.rgba.Amask;
	if(Amask == 0){
		if(Rmask == Gmask && Rmask == Bmask) return GRAY;
		// RGB 8, 16, 24, 32
		if(bit_per_pixel == 8 && Rmask == 7 && Gmask == 7 && Bmask == 3) return RGB; // R3G3B2
		if(bit_per_pixel == 16 && Rmask == 31 && Gmask == 63 && Bmask == 31) return RGB; // R5G6B5
		if(bit_per_pixel == 24 && Rmask == 0xff && Gmask == 0xff00 && Bmask == 0xff0000) return RGB; //R8G8B8
		if(bit_per_pixel == 32 && Rmask == 0xff && Gmask == 0xff00 && Bmask == 0xff0000) return RGB; //R8G8B8
	}else{
		if(Rmask == Gmask && Rmask == Bmask) return GRAY_ALPHA;
		// RGBA 8, 16, 24, 32
		// FIXME
		// if(bit_per_pixel == 8 && Rmask == && Gmask == && Bmask == && Amask == ) return RGB;
		// if(bit_per_pixel == 16 && Rmask == && Gmask == && Bmask == && Amask == ) return RGB;
		// if(bit_per_pixel == 24 && Rmask == && Gmask == && Bmask == && Amask == ) return RGB;
		if(bit_per_pixel == 32 && Rmask == 0xff && Gmask == 0xff00 && Bmask == 0xff0000
			&& Amask == 0xff000000) return RGB_ALPHA; //R8G8B8A8
	}

	return MASK;
}


