#include "position3d.h"

#include <math.h>
#include <iostream>
using namespace std;

#ifndef M_PI
# define M_PI		3.14159265358979323846	/* pi */
#endif
#ifndef M_PI_2
# define M_PI_2		1.57079632679489661923	/* pi/2 */
#endif
#ifndef M_PI_4
# define M_PI_4		0.78539816339744830962	/* pi/4 */
#endif

// (x, y) の極座標の角度を返す
// x == 0 && y == 0 のときを事前に調べること
double radian(double x, double y){
	if(x == 0.0 && y == 0.0) return 0.0;	// 不適切な値

	if(x == 0.0){
		if(y > 0.0)
			return M_PI_2;
		else
			return M_PI + M_PI_2;
	}

	if(y == 0.0){
		if(x > 0.0)
			return 0.0;
		else
			return M_PI;
	}

	if(y > 0.0){
		if(x > 0.0)
			return atan(y / x);
		else
			return M_PI - atan(y / (-x));
	}else{
		if(x < 0.0)
			return M_PI + atan(y / x);
		else
			return 2 * M_PI - atan((-y) / x);
		
	}
}

// 原点を中心に回転する
// 角度はラジアン
/*
// around x
	y = sqrt(y*y + z*z)cos(atan(z / y) + anglex);
	z = sqrt(y*y + z*z)sin(atan(z / y) + anglex);

// around y
	z = sqrt(x*x + z*z)cos(atan(x / z) + angley);
	x = sqrt(x*x + z*z)sin(atan(x / z) + angley);

// around z
	x = sqrt(y*y + x*x)cos(atan(y / x) + anglez);
	y = sqrt(y*y + x*x)sin(atan(y / x) + anglez);
*/
void position3d::rotate(double anglex, double angley, double anglez){

	double sq;	// sqrt
	double at;	// arctan

// around x
	if(anglex){
	if(!((y == 0) && (z == 0))){
		at = radian(y, z) + anglex;
		sq = sqrt(y*y + z*z);
		y = sq * cos(at);
		z = sq * sin(at);
	}}

// around y
	if(angley){
	if(!((z == 0) && (x == 0))){
		at = radian(z, x) + angley;
		sq = sqrt(z*z + x*x);
		z = sq * cos(at);
		x = sq * sin(at);
	}}

// around z
	if(anglez){
	if(!((x == 0) && (y == 0))){
		at = radian(x, y) + anglez;
		sq = sqrt(x*x + y*y);
		x = sq * cos(at);
		y = sq * sin(at);
	}}

}

void position3d::lengthen(double d){
	double r = sqrt(x*x + y*y + z*z);
	if(r == 0.0) return;

	x = (r + d) * (x / r);
	y = (r + d) * (y / r);
	z = (r + d) * (z / r);
	
}


