#include "rect.h"


bool rect::operator==(const rect& B){
	if(x == B.x
	&& y == B.y
	&& w == B.w
	&& h == B.h) return 1;
	return 0;
}

bool rect::operator!=(const rect& B){
	if(*this == B) return 0;
	return 1;
}

void rect::set(int x_, int y_, unsigned w_, unsigned int h_){
	x = x_;
	y = y_;
	w = w_;
	h = h_;
}

int is_rects_intersect_implement(const rect& A, const rect& B){
	// A.x <= B.x
	if(A.x + (int)A.w >= B.x
		&&	!(A.y + (int)A.h < B.y || B.y + (int)B.h < A.y)
	) return 1;

	return 0;
}

int is_rects_intersect(const rect& A, const rect& B){
	if(A.x <= B.x) return is_rects_intersect_implement(A, B);
	return is_rects_intersect_implement(B, A);
}

int merge_rects_implement(rect *A, rect *B, rect *C){

	// A->x <= B->x
	if(!(A->x + (int)A->w >= B->x
	&&	!(A->y + (int)A->h < B->y || B->y + (int)B->h < A->y))
	) return 0;

	int pattern = 0;
	if(A->x + A->w <= B->x + B->w){
		if(A->y < B ->y){
			if(A->y + A->h <= B->y + B->h){
				pattern = 0;
			}else{
				pattern = 1;
			}
		}else{
			if(A->y + A->h <= B->y + B->h){
				pattern = 2;
			}else{
				pattern = 3;
			}
		}
	}else{
		if(A->y < B ->y){
			if(A->y + A->h <= B->y + B->h){
				pattern = 4;
			}else{
				pattern = 5;
			}
		}else{
			if(A->y + A->h <= B->y + B->h){
				pattern = 6;
			}else{
				pattern = 7;
			}
		}
	}

	if(pattern == 0){
		C->set(	B->x,
				A->y + A->h,
				B->w,
				B->y + B->h - A->y - A->h);
		B->set( A->x + A->w,
				B->y,
				B->x + B->w - A->x - A->w,
				A->y + A->h - B->y);
		return 3;
	}else if(pattern == 1){
		B->set(	A->x + A->w,
				B->y,
				B->x + B->w - A->x - A->w,
				B->h);
		return 2;
	}else if(pattern == 2){
		A->set(	A->x,
				A->y,
				B->x - A->x,
				A->h);
		return 2;
	}else if(pattern == 3){
		C->set(	A->x + A->w,
				A->y,
				B->x + B->w - A->x - A->w,
				B->y + B->h - A->y);
		B->set(	B->x,
				B->y,
				B->w,
				A->y - B->y);
		return 3;
	}else if(pattern == 4){
		B->set(	B->x,
				A->y + A->h,
				B->w,
				B->y + B->h - A->y - A->h);
		return 2;
	}else if(pattern == 5){
		return 1;
	}else if(pattern == 6){
		C->set(	B->x,
				A->y + A->h,
				B->w,
				B->y + B->h - A->y - A->h);
		B->set(	B->x,
				B->y,
				B->w,
				A->y - B->y);
		return 3;
	}
	// else (pattern == 7){
		B->set(	B->x,
				B->y,
				B->w,
				A->y - B->y);
		return 2;
	// }
}

int merge_rects(rect *A, rect *B, rect *C){
	if(A->x <= B->x) return merge_rects_implement(A, B, C);
	return merge_rects_implement(B, A, C);
}

/*! src  dstϰǼ
	src  dstΰ˾ǤŤʤʤ true
	Ǥʤ false
*/
bool clipping_rects(rect *src, rect *dst){

	/* x, w */
	if(src->x < dst->x){
		src->w -= dst->x - src->x;
		src->x = dst->x;
	}else if(src->x > dst->x + (int)dst->w){
		return false;
	}

	if(src->x + (int)src->w < dst->x){
		return false;
	}else if(src->x + (int)src->w > dst->x + (int)dst->w){ // src->x <= dst->x
		src->w = dst->x + (int)dst->w - src->x;
	}


	/* y, h */
	if(src->y < dst->y){
		src->h -= dst->y - src->y;
		src->y = dst->y;
	}else if(src->y > dst->y + (int)dst->h){
		return false;
	}
	if(src->y + (int)src->h < dst->y){
		return false;
	}else if(src->y + (int)src->h > dst->y + (int)dst->h){ // src->y <= dst->y
		src->h = dst->y + (int)dst->h - src->y;
	}

	return true;
}

