
#include <set>
#include "screen.h"
#include "image.h"
#include "SDL_create_surface.h"
#include <SDL.h>

// rect  SDL_RectؤѴ
SDL_Rect exchange(rect *src);

screen::screen(void)
{
	if(SDL_WasInit(SDL_INIT_VIDEO) == 0)
		SDL_InitSubSystem(SDL_INIT_VIDEO);
}

screen::~screen(void){
}

int screen::set_screen(int width, int height, int bpp, int flags)
{

	// flags Ѵ
	unsigned int SDL_flags = 0;
	if(flags&SWSURFACE) SDL_flags |= SDL_SWSURFACE;
	if(flags&HWSURFACE) SDL_flags |= SDL_HWSURFACE;
	if(flags&ASYNCBLIT) SDL_flags |= SDL_ASYNCBLIT;
	if(flags&ANYFORMAT) SDL_flags |= SDL_ANYFORMAT;
	if(flags&HWPALETTE) SDL_flags |= SDL_HWPALETTE;
	if(flags&DOUBLEBUF) SDL_flags |= SDL_DOUBLEBUF;
	if(flags&FULLSCREEN) SDL_flags |= SDL_FULLSCREEN;
	if(flags&OPENGL) SDL_flags |= SDL_OPENGL;
	if(flags&OPENGLBLIT) SDL_flags |= SDL_OPENGLBLIT;
	if(flags&RESIZABLE) SDL_flags |= SDL_RESIZABLE;
	if(flags&NOFRAME) SDL_flags |= SDL_NOFRAME;

	surface = SDL_SetVideoMode(width, height, bpp, SDL_flags);
	if(surface == NULL){
		return 1;
	}else{
		return 0;
	}
}


int screen::set_surface(image *s, rect *source, rect *destination){
	SDL_Surface *surf = create_sdl_surface(s);
	int ret = set_surface(surf, source, destination);
	SDL_FreeSurface(surf);

	return ret;
}


int screen::set_surface(SDL_Surface *s, rect *source, rect *destination){

	if(source == 0){
		if(destination == 0){
			rect src = rect(0, 0, s->w, s->h);
			rect dst = rect(0, 0, surface->w, surface->h);
			return set_surface_imp(s, &src, &dst);
		}else{
			rect src = rect(0, 0, s->w, s->h);
			return set_surface_imp(s, &src, destination);
		}
	}

	return set_surface_imp(s, source, destination);

}

int screen::set_surface_imp(SDL_Surface *s, rect *source, rect *destination){

	/* clippng */
	rect *t = (rect *)malloc(sizeof(rect));
	t->set(0, 0, s->w, s->h);
	if(!clipping_rects(source, t)) return 0;
	t->set(0, 0, surface->w, surface->h);
	if(!clipping_rects(destination, t)) return 0;
	free(t);

	if(destination->w > source->w){
		destination->w = source->w;
	}else{
		source->w = destination->w;
	}
	if(destination->h > source->h){
		destination->h = source->h;
	}else{
		source->h = destination->h;
	}

	/* blit */
	SDL_Rect src = exchange(source);
	SDL_Rect dst = exchange(destination);
	SDL_BlitSurface(s, &src, surface, &dst);

	rects.insert(*destination);

	return 1;
}

void screen::update(void){
	int size = rects.size();
	SDL_Rect *sdl_rects = (SDL_Rect *)malloc(size * sizeof(SDL_Rect));
	int i = 0;
	for(std::set<rect>::iterator itr = rects.begin();
			itr != rects.end(); itr++){
		sdl_rects[i].x = itr->x;
		sdl_rects[i].y = itr->y;
		sdl_rects[i].w = itr->w;
		sdl_rects[i].h = itr->h;
		i++;
	}

	SDL_UpdateRects(surface, rects.size(), sdl_rects);

	rects.clear();
	free(sdl_rects);
}

SDL_Rect exchange(rect *src){
	SDL_Rect dst;
	dst.x = src->x;
	dst.y = src->y;
	dst.w = src->w;
	dst.h = src->h;

	return dst;
}

