#include "tetris.h"

// rand
#include <stdlib.h>
#include <time.h>

/*
	֥åΥǡ 5 * 5ǻ
	֥åν֤ (4, -3)
	֥å (2, 2)濴˲ž
*/

/*
block_type 0 
*/
const int num_of_block_types = 7;

tetris::tetris(void){
	blocks = new char[5 * num_of_block_types];
						// 8421
	blocks[0] =	0x00;	//00000
	blocks[1] =	0x00;	//00000
	blocks[2] =	0x0c;	//0##00
	blocks[3] =	0x0c;	//0##00
	blocks[4] =	0x00;	//00000

	blocks[5] =	0x00;	//00000
	blocks[6] =	0x00;	//00000
	blocks[7] =	0x0f;	//0####
	blocks[8] =	0x00;	//00000
	blocks[9] =	0x00;	//00000

	blocks[10] =	0x00;	//00000
	blocks[11] =	0x08;	//0#000
	blocks[12] =	0x0e;	//0###0
	blocks[13] =	0x00;	//00000
	blocks[14] =	0x00;	//00000

	blocks[15] =	0x00;	//00000
	blocks[16] =	0x02;	//000#0
	blocks[17] =	0x0e;	//0###0
	blocks[18] =	0x00;	//00000
	blocks[19] =	0x00;	//00000

	blocks[20] =	0x00;	//00000
	blocks[21] =	0x06;	//00##0
	blocks[22] =	0x0c;	//0##00
	blocks[23] =	0x00;	//00000
	blocks[24] =	0x00;	//00000

	blocks[25] =	0x00;	//00000
	blocks[26] =	0x0c;	//0##00
	blocks[27] =	0x06;	//00##0
	blocks[28] =	0x00;	//00000
	blocks[29] =	0x00;	//00000

	blocks[30] =	0x00;	//00000
	blocks[31] =	0x04;	//00#00
	blocks[32] =	0x0e;	//0###0
	blocks[33] =	0x00;	//00000
	blocks[34] =	0x00;	//00000

	current_block = new char[5];
	
	init();
}

tetris::~tetris(void){
	delete[] blocks;
	delete[] current_block;
}

void tetris::init(void){
	clear_map();
	srand((unsigned) time(NULL));
    set_current_block_type(rand() % 7);
    set_next_block_type(rand() % 7);
	set_block_position(1, -2);
}

bool tetris::decide(void){
	if(check_collision(block_x, block_y + 1)){
		put_block();
		delete_line();
		// ४СȽ
		if(!get_new_block()){
			init();
			return false;
		}
	}
	return true;
}

void tetris::put_block(void){
	for(int i = 0; i < 5; i++){
		for(int j = 0; j < 5; j++){
			if(get_block(current_block, i, j)) set_map(i + block_x, j + block_y, true);
		}
	}

}

int tetris::delete_line(void){
	for(int j = 0; j < 18; j++){
		for(int i = 0; i < 10; i++){
			if(!get_map(i, j)) break;
			if(i == 9){ // (x, j)Ԥ
				// FIXME ǡ¤ˤʤ
				for(int k = j; k > 0; k--){
					map[2*k] = map[2*k - 2];
					map[2*k + 1] = map[2*k -1];
				}
				map[0] = 0x00;
				map[1] = 0x00;
				j--;
			}
		}
	}
	
	return 0;
}

bool tetris::get_new_block(void){
    set_current_block_type(next_block_type);
    set_next_block_type(rand() % 7);
	set_block_position(1, -2);
	return !(check_collision(block_x, block_y));
}

void tetris::clear_map(void){
	for(int i = 0; i < 36; i++)
		map[i] = 0x00;
}

void tetris::set_map(int x, int y, bool value){
	if(value){
		if(x < 8){
			map[y*2] |= 0x01 << x;
		}else{
			map[y*2 + 1] |= 0x01 << (x - 8);
		}
	}else{
		if(x < 8){
			if((map[y*2] >> x) & 0x01) map[y*2] -= 0x01 << x;
		}else{
			if((map[y*2 + 1] >> (x - 8)) & 0x01) map[y*2 + 1] -= 0x01 << (x - 8);
		}
	}
}

void tetris::set_current_block_type(int type){
	current_block_type = type;
	copy_block(blocks + current_block_type * 5, current_block);
}

void tetris::set_next_block_type(int type){
	next_block_type = type;
}

void tetris::set_block_position(int x, int y){
	block_x = x;
	block_y = y;
}


bool tetris::get_map(int x, int y){
//	if(x < 0 || x > 9 || y < 0 || y > 17) return true;
	if(x < 0 || x > 9 || y > 17) return true;
	if(y < 0) return false;
	if(x < 8){
		return (map[y*2] >> x) & 0x01;
	}else{
		return (map[y*2 + 1] >> (x - 8)) & 0x01;
	}
}

bool tetris::get_block(char *src, int x, int y){
	return ((src[y] >> x) & 0x01);
}

bool tetris::get_block(int x, int y){
	return get_block(current_block, x, y);
}

bool tetris::move_right(void){
	if(!check_collision(block_x - 1, block_y)){
		block_x -= 1;
		return true;
	}
		
	return false;
}

bool tetris::move_left(void){
	if(!check_collision(block_x + 1, block_y)){
		block_x += 1;
		return true;
	}
	return false;
}

bool tetris::move_down(void){
	if(!check_collision(block_x, block_y + 1)){
		block_y += 1;
		return true;
	}
	return false;
}

void tetris::move_buttom(void){
	while(move_down()){}
}

bool tetris::turn_right(void){
	if(current_block_type == 0) return false; // žʤ֥å

	char temp[5];
	for(int j = 0; j < 5; j++)
		for(int i = 0; i < 5; i++){
			set_block(temp, j, 4 - i, get_block(i, j));
		}

	if(!check_collision(temp, block_x, block_y)){
		copy_block(temp, current_block);
		return true;
	}
	return false;
}

bool tetris::turn_left(void){
	if(current_block_type == 0) return false; // žʤ֥å

	char temp[5];
	for(int i = 0; i < 5; i++)
		for(int j = 0; j < 5; j++)
			set_block(temp, 4 - j, i, get_block(i, j));

	if(!check_collision(temp, block_x, block_y)){
		copy_block(temp, current_block);
		return true;
	}
	return false;
}


bool tetris::check_collision(char *src, int x, int y){
	for(int i = 0; i < 5; i++){
		for(int j = 0; j < 5; j++){
			if(get_block(src, i, j) && get_map(i + x, j + y)){
				return true;
			}
		}
	}

	return false;
}

bool tetris::check_collision(int x, int y){
	return check_collision(current_block, x, y);
}

void tetris::set_block(char *dst, int x, int y, bool value){
	if(value){
		dst[y] |= 0x01 << x;
	}else{
		if((dst[y] >> x) & 0x01) dst[y] -= 0x01 << x;
	}
}

void tetris::copy_block(char *src, char*dst){
	for(int i = 0; i < 5; i++){
		dst[i] = src[i];
	}
}

