#ifndef __camera_template_h_
#define __camera_template_h_

#include "gl_projection.h"

class camera_template :public window_template{
public:
	camera_template(void);
	~camera_template(void);

	int initialize(void);
	int finalize(void);

	int display(void);
	int resize(int resize_w, int resize_h);

	int loop(void);
	int event(SDL_Event *event);
	int keyhold(Uint8 *keystate);
private:
	gl_projection *camera;
};

camera_template::camera_template(void){
}

camera_template::~camera_template(void){
	finalize();
}

inline int camera_template::initialize(void){
	camera = new gl_projection;
	camera->set_perspective(60.0, (GLdouble)(window->get_width()) / (GLdouble)(window->get_height()), 0.001, 30.0);
	camera->distance(1.8);
	return 0;
}

inline int camera_template::finalize(void){
	return 0;
}

inline int camera_template::display(void){
	camera->set_GL_PROJECTION();
	return 0;
}

inline int camera_template::resize(int resize_w, int resize_h){
	camera->set_aspect((double)resize_w / (double)resize_h);
	return 0;
}

inline int camera_template::loop(void){
	return 0;
}

inline int camera_template::event(SDL_Event *event){
	switch(event->type){
		case SDL_KEYDOWN:
			switch(event->key.keysym.sym){
					default:
					break;
			}
			break;
		default:
			break;
	}

	return 0;
}

inline int camera_template::keyhold(Uint8* keystate){
	if(keystate[SDLK_i]) camera->roll(30.0, 0.0);
	if(keystate[SDLK_k]) camera->roll(-30.0, 0.0);
	if(keystate[SDLK_j]) camera->roll(0.0, 30.0);
	if(keystate[SDLK_l]) camera->roll(0.0, -30.0);
	if(keystate[SDLK_z]) camera->distance(0.5);
	if(keystate[SDLK_x]) camera->distance(-0.5);
	return 0;
}

#endif

