#ifndef __texture_template_h_
#define __texture_template_h_

#include "opengl_texture.h"
#include "gl_texture.h"
#include "image.h"
#include "font_bdf.h"
#include "draw_bdf.h"

#include <cstdlib>

class texture_template :public window_template{
public:
	texture_template(void);
	~texture_template(void);

	int initialize(void);
	int finalize(void);

	int display(void);
	int resize(int resize_w, int resize_h);

	int loop(void);
	int event(SDL_Event *event);

	int keyhold(Uint8* keystate);

//	GLuint texture_number;
	image *texture_image;
	opengl_texture texture;
private:
};

texture_template::texture_template(void){
}

texture_template::~texture_template(void){
	finalize();
}

inline int texture_template::initialize(void){
/*
	texture_image = new image_png;
	if((texture_image->open("/home/hiro/devel/resources/100x100blue.png")) == false){
		cout << "error tex->open" << endl;
		return 1;	// FIXME 顼
	}
*/
	font_bdf *kanji = new font_bdf;
	if((kanji->open("./mplus_f12r.bdf")) != 0){
		//cout << "error texture_template.h:font_bdf" << endl;
	}
	if((kanji->open("./mplus_j12r.bdf")) != 0){
		//cout << "error texture_template.h:font_bdf" << endl;
	}
	texture_image = draw_bdf("tetris", kanji);
	delete kanji;

	expand_bit_image(texture_image);
	texture.make_texture(texture_image);

	return 0;
}

inline int texture_template::finalize(void){
	delete texture_image;
	return 0;
}

inline void dispaly_square_texture(float x0, float y0, float w, float h, opengl_texture *texture){
		glTexCoord2f(0.0, (float)texture->texture_image->height / (float)texture->height);
		glVertex3f(x0, y0, 0.0);

		glTexCoord2f(0.0, 0.0);
		glVertex3f(x0, y0 + h, 0.0);

		glTexCoord2f((float)texture->texture_image->width / (float)texture->width , 0.0);
		glVertex3f(x0 + w, y0 + h, 0.0);

		glTexCoord2f((float)texture->texture_image->width / (float)texture->width, (float)texture->texture_image->height / (float)texture->height);
		glVertex3f(x0 + w, y0, 0.0);
}

inline int texture_template::display(void){
	glEnable(GL_TEXTURE_2D);
	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);
	glBindTexture(GL_TEXTURE_2D, texture.texture_number);

	glBegin(GL_QUADS);
		dispaly_square_texture(0.3, 0.3, 0.6, 0.3, &texture);
	glEnd();

	glDisable(GL_TEXTURE_2D);

	return 0;
}

inline int texture_template::resize(int resize_w, int resize_h){
	return 0;
}

inline int texture_template::loop(void){
	return 0;
}

inline int texture_template::event(SDL_Event *event){
	return 0;
}

inline int texture_template::keyhold(Uint8* keystate){
	return 0;
}

#endif

