#include "delaunay.h"

#include <boost/test/unit_test.hpp>
using namespace boost::unit_test_framework;

#include <iostream>
#include <iomanip>
using namespace std;

void first_test(void){
/*
	SDelauney plane;
	plane.DoTest();
*/

#if 0
// init
	// clear();
	plane.clear();
	BOOST_CHECK_EQUAL(plane.CountPt(), 0);
	BOOST_CHECK_EQUAL(plane.CountTri(), 0);
	

	// void InitPlane(int w, int h);
	InitPlane(10, 10);

// point
	// AddPtPoss
	for(int i = 1; i < 4; i++)
		for(int j = 1; j < 4; j++)
			plane.AddPtPos((double)i, (double)j);

	// GetPtPos	
	for(int i = 1; i < 4; i++){
			double x, y;
			plane.GetPtPos(i, x, y);
			BOOST_CHECK_EQUAL(x, (double)i);
	}

// triangle	
#endif

}

test_suite *init_unit_test_suite(int argc, char *argv[]){
	test_suite *test = BOOST_TEST_SUITE("tetris test");
	test->add(BOOST_TEST_CASE(&first_test));

	return test;
}


#if 0
// ƥѴؿ
bool DoTest();
bool Test1();
bool Test2();
bool Test2_1();
bool Test2_2();
bool Test2_3();
bool Test2_4();
bool Test4();
bool Test4_1();
bool Test6();
bool Test6_1();
bool Test6_2();
bool Test7();
bool Test8();
bool Test9();



/////////////////////////////////////////////////////////////
//
// test codes

bool SDelauney::DoTest()
{
	if (!Test1()) goto error_test;
	if (!Test2()) goto error_test;
	if (!Test4()) goto error_test;
	if (!Test6()) goto error_test;
	if (!Test7()) goto error_test;
	if (!Test8()) goto error_test;
	if (!Test9()) goto error_test;

	printf("====  All tests have successfully passed! (^O^) ====\n");
	return true;

error_test:
	printf("****  Error occured. sorry some test hasnt passed (- -) ****\n");
	return false;
}

//FIXME
bool SDelauney::Test1()
{
	int i, n;
	double x, y;
	int ip0, ip1, ip2;

	Clear();

	for (i=0; i<500; i++) {
		n = AddPtToArray(1.0*i, -1.0*i);
		if (n!=i) printf("fatal error:Test1:1\n");
	}

	AddPtToArray(10.0, -10.0);

	n = CountPt();
	printf("count: %d\n", n);

	for (i=0; i<n; i++) {
		GetPtPos(i, x, y);
		printf("(%f %f)\n", x, y);
	}

	//printf("count: %d\ncapacity: %d\n", m_nPt, m_nPtCapacity);

	STri *pTri;

	for (i=0; i<1100; i++) {
		pTri = new STri(i, i+1, i+2);
		n = AddTriToArray(pTri);
		if (n!=i) printf("fatal error:Test1:2\n");
	}

	n = CountTri();
	printf("tri count: %d\n", n);

	for (i=0; i<n; i++) {
		GetPtOfTri(i, ip0, ip1, ip2);
		printf("(%d %d %d)\n", ip0, ip1, ip2);
	}		

	printf("tri count: %d\ntri\n", m_pTri.size());

	printf("====  Test 1 have successfully passed! (^O^) ====\n");
	return true;
}

bool SDelauney::Test2()
{
	Clear();

	AddPtToArray(2.0, 0.0);
	AddPtToArray(3.0, 2.0);
	AddPtToArray(7.0, 2.0);
	AddPtToArray(1.0, 3.0);
	AddPtToArray(5.0, 4.0);

	if (!Test2_1()) goto error_test2;
	if (!Test2_2()) goto error_test2;
	if (!Test2_3()) goto error_test2;
	if (!Test2_4()) goto error_test2;

	printf("====  Test 2 have successfully passed! (^O^) ====\n");
	return true;

error_test2:
	printf("****  Error occured (- -) ****\n");
	return false;
}

bool SDelauney::Test2_1()
{
	int i, e;

	printf("*** Test2_1() ***\n");

	ClearTriArray();
	
	STri *pTri;
	pTri = new STri(0, 1, 2);
	AddTriToArray(pTri);

	pTri = new STri(0, 1, 3);
	AddTriToArray(pTri);

	SetAdjacent(0, 1);

	printf("tri 0\n");
	for (i=0; i<3; i++) {
		e=GetAdjacent(0, i);
		printf("adj(%d)=%d\n", i, e);
		switch (i) {
			case 0: if (e!=-1) return false; else break;
			case 1: if (e!=-1) return false; else break;
			case 2: if (e!=1) return false; else break;
		}
	}

	printf("tri 1\n");
	for (i=0; i<3; i++) {
		e=GetAdjacent(1, i);
		printf("adj(%d)=%d\n", i, e);
		switch (i) {
			case 0: if (e!=-1) return false; else break;
			case 1: if (e!=-1) return false; else break;
			case 2: if (e!=0) return false; else break;
		}
	}

	return true;
}

bool SDelauney::Test2_2()
{
	int i, e;

	printf("*** Test2_2() ***\n");

	ClearTriArray();

	STri *pTri;
	pTri = new STri(0, 2, 1);
	AddTriToArray(pTri);

	pTri = new STri(1, 3, 0);
	AddTriToArray(pTri);

	SetAdjacent(0, 1);

	printf("tri 0\n");
	for (i=0; i<3; i++) {
		e=GetAdjacent(0, i);
		printf("adj(%d)=%d\n", i, e);
		switch (i) {
			case 0: if (e!=-1) return false; else break;
			case 1: if (e!=1) return false; else break;
			case 2: if (e!=-1) return false; else break;
		}
	}

	printf("tri 1\n");
	for (i=0; i<3; i++) {
		e=GetAdjacent(1, i);
		printf("adj(%d)=%d\n", i, e);
		switch (i) {
			case 0: if (e!=-1) return false; else break;
			case 1: if (e!=0) return false; else break;
			case 2: if (e!=-1) return false; else break;
		}
	}

	return true;
}

bool SDelauney::Test2_3()
{
	int i, e;

	printf("*** Test2_3() ***\n");

	ClearTriArray();

	STri *pTri;
	pTri = new STri(1, 0, 2);
	AddTriToArray(pTri);

	pTri = new STri(3, 1, 0);
	AddTriToArray(pTri);

	SetAdjacent(0, 1);

	printf("tri 0\n");
	for (i=0; i<3; i++) {
		e=GetAdjacent(0, i);
		printf("adj(%d)=%d\n", i, e);
		switch (i) {
			case 0: if (e!=-1) return false; else break;
			case 1: if (e!=-1) return false; else break;
			case 2: if (e!=1) return false; else break;
		}
	}

	printf("tri 1\n");
	for (i=0; i<3; i++) {
		e=GetAdjacent(1, i);
		printf("adj(%d)=%d\n", i, e);
		switch (i) {
			case 0: if (e!=0) return false; else break;
			case 1: if (e!=-1) return false; else break;
			case 2: if (e!=-1) return false; else break;
		}
	}

	return true;
}

bool SDelauney::Test2_4()
{
	int i, e;

	printf("*** Test2_4() ***\n");

	ClearTriArray();

	STri *pTri;
	pTri = new STri(0, 2, 4);
	AddTriToArray(pTri);

	pTri = new STri(3, 1, 0);
	AddTriToArray(pTri);

	// ĤⶦդϤʤΤǼԤϤ
	if (SetAdjacent(0, 1)) {
		printf("SetAdjacent return value is wrong\n");
		return false;
	}

	printf("tri 0\n");
	for (i=0; i<3; i++) {
		e=GetAdjacent(0, i);
		printf("adj(%d)=%d\n", i, e);
		if (e!=-1) return false;
	}

	printf("tri 1\n");
	for (i=0; i<3; i++) {
		e=GetAdjacent(1, i);
		printf("adj(%d)=%d\n", i, e);
		if (e!=-1) return false;
	}

	return true;
}

// IsAdjacent()Υƥ
bool SDelauney::Test4()
{
	if (!Test4_1()) goto error_test4;

	printf("====  Test 4 have successfully passed! (^O^) ====\n");
	return true;

error_test4:
	printf("****  Error occured (- -) ****\n");
	return false;
}

bool SDelauney::Test4_1()
{
	Clear();

	AddPtToArray(2.0, 0.0);
	AddPtToArray(3.0, 2.0);
	AddPtToArray(7.0, 2.0);
	AddPtToArray(1.0, 3.0);
	
	STri *pTri;
	int iTri0, iTri1;
	int c0, c1;

	pTri = new STri(0, 1, 2);
	iTri0 = AddTriToArray(pTri);

	pTri = new STri(1, 3, 0);
	iTri1 = AddTriToArray(pTri);

	if (!SetAdjacent(iTri0, iTri1)) return false;		

	if (!IsAdjacent(iTri0, iTri1, c0, c1)) return false;

	printf("common edge of tri0 = %d\n", c0);
	printf("common edge of tri1 = %d\n", c1);

	return true;
}

// SwapDiagonal()Υƥ
bool SDelauney::Test6()
{
	if (!Test6_1()) goto error_test6;
	if (!Test6_2()) goto error_test6;

	printf("====  Test 6 have successfully passed! (^O^) ====\n");
	return true;

error_test6:
	printf("****  Error occured (- -) ****\n");
	return false;
}

// ñʾ
bool SDelauney::Test6_1()
{
	Clear();

	AddPtToArray(2.0, 0.0);
	AddPtToArray(7.0, 4.0);
	AddPtToArray(4.0, 5.0);
	AddPtToArray(1.0, 3.0);
	
	STri *pTri;
	int iTri0, iTri1;
	int i;
	int ip[3];

	pTri = new STri(0, 1, 2);
	iTri0 = AddTriToArray(pTri);

	pTri = new STri(2, 0, 3);
	iTri1 = AddTriToArray(pTri);

	if (!SetAdjacent(iTri0, iTri1)) return false;		

	printf("tri0 = ( ");
	GetPtOfTri(iTri0, ip[0], ip[1], ip[2]);
	for (i=0; i<3; i++) {
		printf("%d ", ip[i]);
	}
	printf(")\n");
	for (i=0; i<3; i++) {
		printf("%d\n", GetAdjacent(iTri0, i));
	}

	printf("tri1 = ( ");
	GetPtOfTri(iTri1, ip[0], ip[1], ip[2]);
	for (i=0; i<3; i++) {
		printf("%d ", ip[i]);
	}
	printf(")\n");
	for (i=0; i<3; i++) {
		printf("%d\n", GetAdjacent(iTri1, i));
	}

	if (!SwapDiagonal(iTri0, iTri1)) return false;

	printf("new tri0 = ( ");
	GetPtOfTri(iTri0, ip[0], ip[1], ip[2]);
	for (i=0; i<3; i++) {
		printf("%d ", ip[i]);
	}
	printf(")\n");
	for (i=0; i<3; i++) {
		printf("%d\n", GetAdjacent(iTri0, i));
	}

	printf("new tri1 = ( ");
	GetPtOfTri(iTri1, ip[0], ip[1], ip[2]);
	for (i=0; i<3; i++) {
		printf("%d ", ip[i]);
	}
	printf(")\n");
	for (i=0; i<3; i++) {
		printf("%d\n", GetAdjacent(iTri1, i));
	}

	return true;
}

// ¾λѷ
bool SDelauney::Test6_2()
{
	Clear();

	AddPtToArray(5.0, 0.0);
	AddPtToArray(7.0, 3.0);
	AddPtToArray(3.0, 2.0);
	AddPtToArray(5.0, 5.0);
	AddPtToArray(6.0, 6.0);
	AddPtToArray(9.0, 8.0);
	AddPtToArray(5.0, 10.0);
	AddPtToArray(1.0, 7.0);
	
	STri *pTri;
	int iTri[8];
	int i, j;
	int ip[3];
	int t0, t1;

	pTri = new STri(0, 1, 2);
	iTri[0] = AddTriToArray(pTri);

	pTri = new STri(2, 1, 3);
	iTri[1] = AddTriToArray(pTri);

	pTri = new STri(2, 3, 7);
	iTri[2] = AddTriToArray(pTri);

	pTri = new STri(4, 3, 1);
	iTri[3] = AddTriToArray(pTri);

	pTri = new STri(4, 1, 5);
	iTri[4] = AddTriToArray(pTri);

	pTri = new STri(3, 4, 7);
	iTri[5] = AddTriToArray(pTri);

	pTri = new STri(4, 5, 6);
	iTri[6] = AddTriToArray(pTri);

	pTri = new STri(4, 6, 7);
	iTri[7] = AddTriToArray(pTri);

	for (i=0; i<8; i++) {
		for (j=0; j<8; j++) {
			SetAdjacent(iTri[i], iTri[j]);
		}
	}

	// оݤλѷֹ
	t0 = 1;
	t1 = 2;

	printf("tri%d = ( ", t0);
	GetPtOfTri(iTri[t0], ip[0], ip[1], ip[2]);
	for (i=0; i<3; i++) {
		printf("%d ", ip[i]);
	}
	printf(")\n");
	for (i=0; i<3; i++) {
		printf("%d\n", GetAdjacent(iTri[t0], i));
	}

	printf("tri%d = ( ", t1);
	GetPtOfTri(iTri[t1], ip[0], ip[1], ip[2]);
	for (i=0; i<3; i++) {
		printf("%d ", ip[i]);
	}
	printf(")\n");
	for (i=0; i<3; i++) {
		printf("%d\n", GetAdjacent(iTri[t1], i));
	}

	if (!SwapDiagonal(iTri[t0], iTri[t1])) return false;

	printf("new tri1 = ( ");
	GetPtOfTri(iTri[t0], ip[0], ip[1], ip[2]);
	for (i=0; i<3; i++) {
		printf("%d ", ip[i]);
	}
	printf(")\n");
	for (i=0; i<3; i++) {
		printf("%d\n", GetAdjacent(iTri[t0], i));
	}

	printf("new tri3 = ( ");
	GetPtOfTri(iTri[t1], ip[0], ip[1], ip[2]);
	for (i=0; i<3; i++) {
		printf("%d ", ip[i]);
	}
	printf(")\n");
	for (i=0; i<3; i++) {
		printf("%d\n", GetAdjacent(iTri[t1], i));
	}

	return true;
}

// IsPlusRotation()Υƥ
bool SDelauney::Test7()
{
	Clear();

	if (!IsPlusRotation(2.0, 3.0, -2.0, 2.0)) goto error_test7;
	if (IsPlusRotation(-0.5, 10.0, 3.0, -1.0)) goto error_test7;

	printf("====  Test 7 have successfully passed! (^O^) ====\n");
	return true;

error_test7:
	printf("****  Error occured (- -) ****\n");
	return false;
}

// FindTriContains()Υƥ
bool SDelauney::Test8()
{
	STri *pTri;
	int iTri[8];
	double x, y;
	int i;

	Clear();

	AddPtToArray(5.0, 0.0);
	AddPtToArray(7.0, 3.0);
	AddPtToArray(3.0, 2.0);
	AddPtToArray(5.0, 5.0);
	AddPtToArray(6.0, 6.0);
	AddPtToArray(9.0, 8.0);
	AddPtToArray(5.0, 10.0);
	AddPtToArray(1.0, 7.0);
	
	pTri = new STri(0, 1, 2);
	iTri[0] = AddTriToArray(pTri);

	pTri = new STri(2, 1, 3);
	iTri[1] = AddTriToArray(pTri);

	pTri = new STri(2, 3, 7);
	iTri[2] = AddTriToArray(pTri);

	pTri = new STri(4, 3, 1);
	iTri[3] = AddTriToArray(pTri);

	pTri = new STri(4, 1, 5);
	iTri[4] = AddTriToArray(pTri);

	pTri = new STri(3, 4, 7);
	iTri[5] = AddTriToArray(pTri);

	pTri = new STri(4, 5, 6);
	iTri[6] = AddTriToArray(pTri);

	pTri = new STri(4, 6, 7);
	iTri[7] = AddTriToArray(pTri);
	
	x = 3.0;
	y = 5.0;
	i = FindTriContains(x, y);
	printf("(%f %f) is in triangle %d\n", x, y, i);
	if (i!=2) goto error_test8;

	x = 4.0;
	y = 7.5;
	i = FindTriContains(x, y);
	printf("(%f %f) is in triangle %d\n", x, y, i);
	if (i!=7) goto error_test8;

	x = 7.0;
	y = 5.0;
	i = FindTriContains(x, y);
	printf("(%f %f) is in triangle %d\n", x, y, i);
	if (i!=4) goto error_test8;

	x = 5.0;
	y = 1.0;
	i = FindTriContains(x, y);
	printf("(%f %f) is in triangle %d\n", x, y, i);
	if (i!=0) goto error_test8;

	x = 6.0;
	y = 7.0;
	i = FindTriContains(x, y);
	printf("(%f %f) is in triangle %d\n", x, y, i);
	if (i!=6) goto error_test8;

	x = 0.0;
	y = 0.0;
	i = FindTriContains(x, y);
	printf("(%f %f) is in triangle %d\n", x, y, i);
	if (i!=-1) goto error_test8;

	x = 100.0;
	y = -1200.0;
	i = FindTriContains(x, y);
	printf("(%f %f) is in triangle %d\n", x, y, i);
	if (i!=-1) goto error_test8;

	printf("====  Test 8 have successfully passed! (^O^) ====\n");
	return true;

error_test8:
	printf("****  Error occured (- -) ****\n");
	return false;
}

bool SDelauney::Test9()
{
	STri *pTri;
	int n;
	int ip[3];
	int i, j, a;

	Clear();

	AddPtToArray(0.0, 0.0);
	AddPtToArray(6.0, 0.0);
	AddPtToArray(6.0, 6.0);
	AddPtToArray(0.0, 6.0);

	pTri = new STri(0, 1, 3);
	AddTriToArray(pTri);
	
	pTri = new STri(1, 2, 3);
	AddTriToArray(pTri);

	if (!SetAdjacent(0, 1)) goto error_test9;

	n = CountTri();
	printf("***** before divide *****\n");
	printf("%d tries exist\n", n);

	for (i=0; i<n; i++) {
		GetPtOfTri(i, ip[0], ip[1], ip[2]);
		printf("tri [%d] = ( %d %d %d )\n", i, ip[0], ip[1], ip[2]);
		for (j=0; j<3; j++) {
			a = GetAdjacent(i, j);
			printf("edge(%d) is next to tri(%d)\n", j, a);
		}
	}

	if (!AddPtPos(3, 1)) goto error_test9;

	n = CountTri();
	printf("***** after divide *****\n");
	printf("%d tries exist\n", n);

	for (i=0; i<n; i++) {
		GetPtOfTri(i, ip[0], ip[1], ip[2]);
		printf("tri [%d] = ( %d %d %d )\n", i, ip[0], ip[1], ip[2]);
		for (j=0; j<3; j++) {
			a = GetAdjacent(i, j);
			printf("edge(%d) is next to tri(%d)\n", j, a);
		}
	}

	printf("====  Test 9 have successfully passed! (^O^) ====\n");
	return true;

error_test9:
	printf("****  Error occured (- -) ****\n");
	return false;
}

#endif
