#include "tetris.h"

#include <boost/test/unit_test.hpp>
using namespace boost::unit_test_framework;

#include <iostream>
#include <iomanip>
using namespace std;

void first_test(void){
	// construct
	tetris game;
	for(int i = 0; i < 10; i++){
		for(int j = 0; j < 18; j++){
		BOOST_CHECK_EQUAL(game.get_map(i, j), false);
		}
	}

	// get()
	BOOST_CHECK_EQUAL(game.get_map(0, 0), false);
	game.set_map(1, 1, true);
	BOOST_CHECK_EQUAL(game.get_map(1, 1), true);
	game.set_map(1, 1, false);
	BOOST_CHECK_EQUAL(game.get_map(1, 1), false);

	BOOST_CHECK_EQUAL(game.get_map(9, 17), false);
	BOOST_CHECK_EQUAL(game.get_map(8, 17), false);
	game.set_map(9, 17, true);
	BOOST_CHECK_EQUAL(game.get_map(9, 17), true);
	BOOST_CHECK_EQUAL(game.get_map(8, 17), false);
	game.set_map(9, 17, false);
	BOOST_CHECK_EQUAL(game.get_map(9, 17), false);
	BOOST_CHECK_EQUAL(game.get_map(8, 17), false);

	game.set_current_block_type(0);
	BOOST_CHECK_EQUAL(game.get_block(0, 0), false);
	BOOST_CHECK_EQUAL(game.get_block(0, 1), false);
	BOOST_CHECK_EQUAL(game.get_block(0, 2), false);
	BOOST_CHECK_EQUAL(game.get_block(2, 2), true);

	// collision
	game.set_map(2, 2, true);
	game.set_current_block_type(0);
	BOOST_CHECK_EQUAL(game.check_collision(0, 0), true);
	BOOST_CHECK_EQUAL(game.check_collision(0, 1), false);

	// turn
	game.init();
	game.set_block_position(1, -1);
	game.set_current_block_type(1);
	BOOST_CHECK_EQUAL(game.get_block(2, 1), false);
	game.turn_right();
	BOOST_CHECK_EQUAL(game.get_block(2, 1), true);
	game.turn_left();
	BOOST_CHECK_EQUAL(game.get_block(2, 1), false);

	// clear_map
	game.clear_map();
	for(int i = 0; i < 10; i++){
		for(int j = 0; j < 18; j++){
			BOOST_CHECK_EQUAL(game.get_map(i, j), false);
		}
	}
}

test_suite *init_unit_test_suite(int argc, char *argv[]){
	test_suite *test = BOOST_TEST_SUITE("tetris test");
	test->add(BOOST_TEST_CASE(&first_test));

	return test;
}





